!set lang_exists=yes

!! Ce fichier prsente la question  rsoudre.

Vous jouez  pile ou face contre le serveur. Dans un jeu de pile ou face usuel, chacun
lance une pice, si les deux pices tombent toutes deux sur la mme face, vous avez gagn. Sinon vous
avez perdu.

<p>
Ici, chacun d'entre
vous va choisir un entier. Vous aurez gagn si les deux
entiers sont de mme parit et perdu sinon.
</p><p>
Il faut bien que l'un d'entre vous commence. Mais le problme ici est que vous devez
vous communiquer les entiers choisis sans que l'un d'entre vous essaye de tricher
en changeant la valeur. C'est pour cela qu'on a besoin d'un moyen de vrifier
(ce qu'on fera  l'aide d'une fonction dite d'engagement).
</p><p>
!if $alice issametext serveur
  Cette fois-ci, c'est le serveur qui commence.
  Le serveur va choisir un entier \(n\) sans vous le dire, mais en vous donnant
  un moyen de vrifier ensuite (en vous donnant la fonction d'engagement \(f\) et
  la valeur \(f(n)\)).
  Vous allez ensuite lui dire votre nombre.
  Le serveur vous dira si vous avez gagn ou non. Vous devez vous assurer alors
  qu'il n'a pas trich ...
!else
  Cette fois-ci, c'est vous qui commencez.
  Vous allez choisir un entier \(n\) et donner au serveur une bonne
  <span class="wims_emph">fonction d'engagement \(f\)</span>
  et sa valeur en \(n\).
  Il ne faut bien sr pas que l'adversaire soit capable de trouver rapidement \(n\)
   partir de \(f\) et de \(f(n)\).

  Le serveur va alors choisir un entier. Vous pourrez lui dire si
  c'est lui ou vous qui avez gagn. Mais attention, il vrifiera ensuite que vous ne trichez pas.
!endif
!if $alice issametext serveur
  <p>
  La fonction d'engagement que le serveur va utiliser est la fonction
  </p><div class="wimscenter">
  \(x \mapsto x^{$aph} \bmod $Nr\).
  </div>
  Le serveur choisit un entier \(n\) pair ou impair. Il vous donne son image par \(f\) :
  <div class="wimscenter"> \(f(n) = $z\).</div>
  !if $pile issametext no
    <p>
    A vous maintenant :
    Choisissez un bit \(x\) gal  0 ou 1 et donnez-le au serveur, vous aurez
    gagn si \(n\) est de mme parit que \(x\) et perdu sinon.
     Bien sr, c'est le serveur uniquement qui pourra l'affirmer.
     Mais vous aurez quand mme un moyen de vrifier...
    </p>
  !endif
!else
  <p>
  Vous allez devoir choisir un nombre \(n\) que vous garderez secret
  pour l'instant et une fonction d'engagement \(f\) de
  \((\ZZ/N\ZZ)^*\)
  dans
  \( (\ZZ/N\ZZ)^*\)
  de la forme
  </p>
  <div class="wimscenter">\(x \mapsto x^a \bmod N\).
  </div>
  <p>
  Elle doit tre bijective et  sens unique, c'est--dire qu'il
  soit <em>difficile</em> de calculer sa fonction rciproque.
  Elle va  permettre au serveur de vrifier que vous ne l'avez pas tromp.
  Pour cela, vous devez choisir un entier RSA, c'est--dire
  </p>
  <ul><li>un entier \(N\) produit de deux grands nombres
  premiers distincts (disons plus grands que $borne1)
  </li><li>
  un entier
  \(a\) compris entre $borne2 et \(N - $borne2\)
  </li></ul>
  tels  que la fonction
  <div class="wimscenter">\(f : x \mapsto x^a \bmod N\)
  </div>
  vrifie les conditions prcdentes.
!endif
